Package: VERSO
Version: 1.21.0
Date: 2025-09-23
Title: Viral Evolution ReconStructiOn (VERSO)
Authors@R: c(person("Daniele", "Ramazzotti", role=c("aut"),email="daniele.ramazzotti@unimib.it",
                comment = c(ORCID = "0000-0002-6087-2666")),
    person("Fabrizio","Angaroni",role=c("aut"),email="fabrizio.angaroni@unimib.it"),
    person("Davide","Maspero",role=c("cre","aut"),email="d.maspero@campus.unimib.it"),
    person("Alex","Graudenzi",role=c("aut"),email="alex.graudenzi@unimib.it"),
    person("Luca", "De Sano", role=c("aut"), email="luca.desano@gmail.com",
                comment = c(ORCID = "0000-0002-9618-3774")))
Depends: R (>= 4.1.0)
Imports: utils, data.tree, ape, parallel, Rfast, stats
Suggests: BiocGenerics, BiocStyle, testthat, knitr
Name: VERSO: an R package for the inference of viral evolution models
Description: 
    Mutations that rapidly accumulate in viral genomes during a pandemic can be used to track the evolution of the virus 
    and, accordingly, unravel the viral infection network. 
    To this extent, sequencing samples of the virus can be employed to estimate models from genomic epidemiology and may 
    serve, for instance, to estimate the proportion of undetected infected people by uncovering cryptic transmissions, as 
    well as to predict likely trends in the number of infected, hospitalized, dead and recovered people. 
    VERSO is an algorithmic framework that processes variants profiles from viral samples to produce phylogenetic 
    models of viral evolution. The approach solves a Boolean Matrix Factorization problem with phylogenetic constraints, 
    by maximizing a log-likelihood function. VERSO includes two separate and subsequent steps; in this package we provide 
    an R implementation of VERSO STEP 1. 
Encoding: UTF-8
License: file LICENSE
URL: https://github.com/BIMIB-DISCo/VERSO
BugReports: https://github.com/BIMIB-DISCo/VERSO
biocViews: BiomedicalInformatics, Sequencing, SomaticMutation
RoxygenNote: 7.3.2
VignetteBuilder: knitr
git_url: https://git.bioconductor.org/packages/VERSO
git_branch: devel
git_last_commit: 9a3fa06
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.23
Date/Publication: 2025-10-30
NeedsCompilation: no
Packaged: 2025-10-30 23:34:29 UTC; biocbuild
Author: Daniele Ramazzotti [aut] (ORCID:
    <https://orcid.org/0000-0002-6087-2666>),
  Fabrizio Angaroni [aut],
  Davide Maspero [cre, aut],
  Alex Graudenzi [aut],
  Luca De Sano [aut] (ORCID: <https://orcid.org/0000-0002-9618-3774>)
Maintainer: Davide Maspero <d.maspero@campus.unimib.it>

# Verso

Verso is an application aimed to simplify and standardize automatic
versioning in a continuous delivery context.

## Philosophy

The idea with Verso is to reuse part of the functionality needed in
order to implement Continuous Delivery.

The approach to continuous delivery taken is the multi-repo approach
described well in [this
blog](https://www.thoughtworks.com/insights/blog/architecting-continuous-delivery).
That is, modularization of an application is achieved by breaking out
components that lives in their own version controlled repositories,
with their own delivery pipelines. The components are released to a
binary repository, such as Artifactory or Nexus. The dependencies to
the components may be resolved at various stages depending on the type
of component. In the case of a library the dependency typically is
resolved at build time of the dependent application, by the use of a
dependency manager, such as Maven, Pip, or Conan. In the case of a
service the components are instead resolved at deploy time.

In order to encourage modularization it is important to reduce the
friction involved in creating individual release pipelines for each
component. Likewise, it is also important to minimize the friction and
lead time involved by this multi-repo approach; multi-repo approaches
typically require multiple changes in order for a fix or feature to
end up in production. The suggested approach is to automate versioning
and releases of components, both for staging and trunk (trunk-based
development is favored). Releasing for staging means releasing
candidates for each proposed change (a proposed change is typically
subject to a review, for example pull requests or change
sets). Releasing for trunk means releasing an approved change.

Automatic versioning a component can be solved is various ways, but
the approach suggested with this project is to use a SemVer-like
approach. Depending on the ambition of the user, the approach can
potentially be everything from SemVer to SemVer-like. The reason to
use a SemVer-like approach is to let dependency management look
elegant and conventional. One thing that SemVer for example supports
is the ability to identify the generation of a component, which
simplifies understanding. It can be argued that true SemVer (including
the distinction between major, minor, and patch versions), is
sometimes over-kill for components, at least in small settings, hence
the sloppy interpretation of SemVer.

## Design

The design of this project is not carved in stone. It is not obvious
what to generalize and what to leave to the user to
specialize. Different users could have different source code
management (such as Git, Mercurial or Subversion), different binary
repositories (such as Artifactory or Nexus), and different release
formats (such as Maven, Wheel, Npm, Conan). But one thing is sure, it
is not advisable to implement the same functionality over and over
again for every project that needs to be versioned and released. In
order to maintain a SemVer-like versioning, the version must be
incremented, and valid versions must be distinguished from invalid
ones, and that kind of functionality is not trivial.

Since a SemVer-like versioning has an order, the current version must
somehow be stored; a state must be maintained. How this state is
implemented is a matter of design. One can think of a state maintained
by a binary repository or some database. In this project the source
code management is used. Following the YAGNI design principle, Git
will be used, and only Git. Supporting more version control systems
could be a future improvement of this project. Using tags of Git is
actually quite convenient since several birds are killed with one
stone; tagging revisions that releases are based on is graceful.

## Future improvements

The current design automatically maintains the patch version while the
major and minor part of the version is more or less permanent. A nice
improvement would be to combine the automatic state with a state
maintained by writing change log items in a CHANGELOG file. That way
we would both have nice release notes and automatic versioning. The
major could for example be identified by the CHANGELOG file, and the
patch version could be automatically maintained. Using this approach
would actually allow users to maintain a pure SemVer versioning by
allowing users to write change logs for major and minors, while still
use an automated versioning for patch versions.

## Etymology

The name `Verso` is the result of playing with the word `version`, the
literal meaning of the Italian word `verso` meaning `towards` in
English.

## Installation (from PyPI)

    pip install verso

## Usage (after installation from PyPI)

Get the current version of the Git project of the current directory:

    verso current-version

The command will go through all git tags of the format vX.Y.Z in the
project, order them, and print the latest, without the prefix.

Get the next version of the Git project of the current directory:

    verso next-version

The command will go through all git tags of the format vX.Y.Z in the
project, order them, and print the latest but with the patch version
increased by one.

## Contributions

Contributions are welcome. All functionality must be covered by tests.

## Prerequisites

In order to test application locally Docker and Make must be
installed.

## How to test application

Testing of Verso makes use of Make as a task runner. The following
command runs all tests.

    make test

## How to create a package

    VERSION=X.Y.Z make package

The package will end up in a folder named `dist`.

## How to release application

    VERSION=X.Y.Z make upload-test
    VERSION=X.Y.Z make upload-prod

# learn VERSO phylogenetic tree from data
learn.VERSO.phylogenetic.tree <- function( D, 
                                           alpha = 10^-3, 
                                           beta = 10^-3, 
                                           initialization = NULL, 
                                           keep_equivalent = FALSE, 
                                           marginalize = FALSE,
                                           num_rs = 10, 
                                           num_iter = 10000, 
                                           n_try_bs = 1000, 
                                           num_processes = Inf, 
                                           verbose = TRUE,
                                           log_file = "" ) {
    
    # we remove any NA from data
    if(any(is.na(D))) {
        D[which(is.na(D),arr.ind=TRUE)] <- -3
    }
    storage.mode(D) <- "integer"
    
    equivalent_solutions <- list()
    
    # perform a number of num_rs restarts
    if(num_processes > 1) {
        
        parallel_cl <- makeCluster(num_processes,outfile=log_file)
        
        clusterExport(parallel_cl,varlist=c("D","alpha","beta","initialization","keep_equivalent","marginalize","num_rs","num_iter","n_try_bs","verbose","log_file"),envir=environment())
        clusterExport(parallel_cl,c("MCMC","initialize.B","move.B", "relabeling", "prune.and.reattach", "compute.C"),envir=environment())
        clusterSetRNGStream(parallel_cl,iseed=round(runif(1)*100000))
        
        mcmc_res <- parLapply(parallel_cl,1:num_rs,function(x) {
            
            MCMC( D = D, 
                  alpha = alpha, 
                  beta = beta, 
                  initialization = initialization, 
                  keep_equivalent = keep_equivalent, 
                  marginalize = marginalize, 
                  num_rs = num_rs, 
                  num_iter = num_iter, 
                  n_try_bs = n_try_bs, 
                  rs_i = x, 
                  verbose = verbose, 
                  log_file = log_file )
            
        })
        
        stopCluster(parallel_cl)
        
    }
    else {
        mcmc_res <- list()
        for(i in seq_len(num_rs)) {
            mcmc_res[[i]] <- MCMC( D = D, 
                                   alpha = alpha, 
                                   beta = beta, 
                                   initialization = initialization, 
                                   keep_equivalent = keep_equivalent, 
                                   marginalize = marginalize, 
                                   num_rs = num_rs, 
                                   num_iter = num_iter, 
                                   n_try_bs = n_try_bs, 
                                   rs_i = i, 
                                   verbose = verbose, 
                                   log_file = log_file )
        }
    }

    if(num_rs > 1) {
        best_lik <- c()
        for(i in  1:num_rs) {
            best_lik <- c(best_lik, mcmc_res[[i]]$log_likelihood)
        }
        idx_bjl <- which(best_lik == max(best_lik))
        best_mcmc <- mcmc_res[[idx_bjl[1]]]
        for(i in 2:length(idx_bjl)) {
            best_mcmc$equivalent_solutions <- c(best_mcmc$equivalent_solutions,mcmc_res[[idx_bjl[i]]]$equivalent_solutions)
        }
    }
    else {
        best_mcmc <-  mcmc_res[[1]]
    }
    
    # renaming
    rownames(best_mcmc$B) <- paste0("G",seq_len(nrow(best_mcmc$B)))
    colnames(best_mcmc$B) <- c("Reference",colnames(D)[as.numeric(colnames(best_mcmc$B)[2:ncol(best_mcmc$B)])])
    best_mcmc$C <- matrix(paste0("G",best_mcmc$C),ncol=1)
    rownames(best_mcmc$C) <- rownames(D)
    colnames(best_mcmc$C) <- "Genotype"
    
    return(best_mcmc)
    
}

# perform MCMC
MCMC <- function( D, 
                  alpha = 10^-3, 
                  beta = 10^-3, 
                  initialization = NULL, 
                  keep_equivalent = FALSE, 
                  marginalize = FALSE, 
                  num_rs = 10, 
                  num_iter = 10000, 
                  n_try_bs = 1000, 
                  rs_i = NULL, 
                  verbose = TRUE, 
                  log_file = "" ) {
    
    # initialize B
    if(is.null(initialization)) {
        B <- initialize.B(D)
        
    }
    else {
        B <- initialization
        storage.mode(B) <- "integer"
        if(rs_i > 1) {
            # Restars after the first one start from a different point if 
            # a initial tree was passed (it could be generated by TRAIT or by user)
            for(i in seq(1,ncol(B))) {
                B <- move.B(B)   
            }
        }
    }

    # compute C given B
    res <- compute.C(B,D,alpha,beta,marginalize)
    C <- res$C
    lik <- res$lik
    
    # initialize result variables (best solution for the current restart)
    B_best <- B
    C_best <- C
    lik_best <- lik
    count_lik_best_cons <- 0
    equivalent_solutions <- list()
    if(keep_equivalent) {
        equivalent_solutions[[1]] <- list(B=B_best,C=C_best,log_likelihood=lik_best)
    }
    
    # repeat MCMC moves until num_iter number of iterations is performed
    j = 1
    while(j <= num_iter) {
       
        if(verbose&&(j%%500)==0) {
            cat("\r", 
                "Current best lik. = ",format(lik_best, digit = 2, nsmall = 2), 
                " | Restart # ",rs_i,"/",num_rs," | Iter # ",j, " | Likelihood not improved for ", count_lik_best_cons,"/",n_try_bs," iterations", 
                "     ", 
                sep='', 
                file = log_file, 
                append = TRUE)
        }
        
        # perform a move on B
        B_tmp <- move.B(B)
        
        # compute C at maximun likelihood given B_tmp and returns its likelihood
        res <- compute.C(B_tmp,D,alpha,beta,marginalize)
        C_tmp <- res$C
        lik_tmp <- res$lik
        
        # if likelihood at current step is better than best likelihood, replace best model with current
        if(lik_tmp>lik_best) {
            B_best <- B_tmp
            C_best <- C_tmp
            lik_best <- lik_tmp
            count_lik_best_cons <- 0
            B <- B_best
            C <- C_best
            lik <- lik_best
            equivalent_solutions <- list()
            if(keep_equivalent) {
                equivalent_solutions[[1]] <- list(B=B_best,C=C_best,log_likelihood=lik_best)
            }
        }
        else {

            if(lik_tmp==lik_best) {
                if(keep_equivalent) {
                    equivalent_solutions[[(length(equivalent_solutions)+1)]] <- list(B=B_tmp,C=C_tmp,log_likelihood=lik_tmp)
                }
            }

            # update count
            count_lik_best_cons <- count_lik_best_cons + 1
            if(count_lik_best_cons>n_try_bs) {
                # print a message
                if(verbose) {
                    cat("\r",
                        "Current best lik. = ",format(lik_best, digit = 2, nsmall = 2), 
                        " | Restart # ",rs_i,"/",num_rs," | Iter # ",j, " | Likelihood not improved for ", (count_lik_best_cons-1),"/",n_try_bs," iterations", 
                        "     ", 
                        "\n", 
                        sep='')
                }
                break;
            }
            # take the current state with a probability proportional to the ratio of the two likelihoods
            rho <- min(exp((lik_tmp-lik)),1)
            if(runif(1)<=rho) {
                B <- B_tmp
                C <- C_tmp
                lik <- lik_tmp
            }
        }
        j = j + 1
    }

    return(list(B=B_best,C=C_best,log_likelihood=lik_best,equivalent_solutions=equivalent_solutions))
    
}

# randomly initialize B
initialize.B <- function( D ) {
    
    # data structure where to save B
    B <- array(0L,c((ncol(D)+1),(ncol(D)+1)))
    rownames(B) <- c("r",seq_len(ncol(D)))
    colnames(B) <- c("r",sample(seq_len(ncol(D))))
    diag(B) <- 1L
    B[,1] <- 1L
    
    # add arcs with probability 50% to obtain a random tree topology
    p <- 0.50
    for(i in 2:(nrow(B)-1)) {
        if(runif(1)<p) {
            B[(i+1),] <- B[i,] + B[(i+1),]
        }
    }
    B[which(B>1)] <- 1L
    
    # return B
    return(B)
    
}

# performing either relabeling or edge changing moves on B
move.B <- function( B ) {
    
    # sample a random probability of choosing a move
    p <- runif(1)
    
    # perform pairwise relabeling with 55% probability
    if(p<0.55) {
        
        # nodes relabeling
        B <- relabeling(B=B)
        
    }
    # perform structural moves with 40% probability
    else if(p>=0.55&&p<0.95) {
        
        # prune and reattach
        B <- prune.and.reattach(B=B)
        
    }
    # perform full relabeling with 5% probability
    else if(p>=0.95) {
        
        # random relabeling of all clones
        colnames(B) <- c("r",sample(seq_len((ncol(B)-1))))
        
    }
    
    # return B
    return(B)
    
}

# perform relabeling
relabeling <- function( B ) {
    
    # relabeling
    chosen <- sample(2:ncol(B),2,replace=FALSE)
    tmp <- colnames(B)[chosen[1]]
    colnames(B)[chosen[1]] <- colnames(B)[chosen[2]]
    colnames(B)[chosen[2]] <- tmp
    return(B)
    
}

# perform prune and reattach
prune.and.reattach <- function( B ) {
    
    # change one arch
    is_not_valid <- TRUE
    while(is_not_valid) {
        
        # select source node
        ch_1 <- sample(x=2:nrow(B),size=1)
        ch_1_gen <- B[ch_1,1:ch_1]
        remaing_node <- as.numeric(which(apply(B[,1:ch_1], c(1), FUN = function(x){!all(x == ch_1_gen)})))
        
        # chose the target node from the nodes not included in the subtree where ch_1 is the root
        if(length(remaing_node) > 1) {
            
            ch_2 <- sample(x=remaing_node,size=1)
            
        } else if(length(remaing_node)==1) {
            
            ch_2 <- remaing_node
            
        } else {
            # if there aren't any nodes, select a different source
            next
        }

        # a pair of two nodes is valid if the nodes are not already directly connected
        if(!(all(B[ch_1,1:ch_2]==B[ch_2,1:ch_2])&sum(B[ch_1,])==(sum(B[ch_2,])+1))) {
            is_not_valid <- FALSE
        }
        
    }
    
    descendent_nodes <- setdiff(1:nrow(B), remaing_node)
    
    # extract descendent node submatrix
    rem_B <- B[remaing_node,remaing_node,drop=FALSE]
    new_B <- matrix(data = 0L, nrow = nrow(rem_B), ncol = ncol(B))
    colnames(new_B) <- c(colnames(B)[remaing_node], colnames(B)[descendent_nodes])
    new_B[1:length(remaing_node),1:length(remaing_node)] <- rem_B
    gen_ch_2 <- new_B[which(colnames(new_B)==colnames(B)[ch_2]),1:length(remaing_node)]
    desc_B <- cbind(matrix(rep(gen_ch_2,each=length(descendent_nodes)),  nrow = length(descendent_nodes)), 
                    B[descendent_nodes,descendent_nodes,drop=FALSE])
    new_B <- rbind(new_B,desc_B)
    
    return(new_B)
    
}

# compute attachments matrix C at maximum likelihood given B and D
compute.C <- function( B, D, alpha = 10^-3, beta = 10^-3, marginalize = FALSE) {
    
    # determine indeces to order D such that it matches B
    idx_srt <- as.integer(colnames(B)[2:ncol(B)])
    
    # go through each patient and compute likelihood for all possible attachments
    lik_matrix <- array(0L,c(nrow(D),ncol(B)))
    curr_D <- cbind(rep(1,nrow(D)),D[,idx_srt,drop=FALSE])
    for(k in seq_len(nrow(B))) {
        curr_C = matrix(rep(0L,nrow(B)),nrow=1)
        curr_C[1,k] <- 1L
        r_D_tilde <- (curr_C%*%B)*2
        sum_cell <- as.matrix(sweep(curr_D,MARGIN=2,r_D_tilde,"+"))
        lik_matrix[,k] <- log(beta^Rfast::rowsums(sum_cell==2)) +
            log((1-beta)^Rfast::rowsums(sum_cell==0)) + 
            log((alpha)^Rfast::rowsums(sum_cell==1)) + 
            log((1-alpha)^Rfast::rowsums(sum_cell==3))
    }
    
    # compute maximum likelihood attachments
    C <- Rfast::rowMaxs(lik_matrix,value=FALSE)
    storage.mode(C) <- "integer"
    
    lik <- sum(Rfast::rowMaxs(lik_matrix,value=TRUE))
    
    if(marginalize==TRUE) {
        lik_time <- sum(Rfast::rowsums(lik_matrix))
    }
    else {
        lik_time <- sum(Rfast::rowMaxs(lik_matrix,value=TRUE))
    }
    
    # return maximum likelihood attachments
    return(list(C=C,lik=lik))
    
}

# remove any indistinguishable variant from input data
check.indistinguishable <- function( data ) {
    
    # check for indistinguishable events
    indistinguishable <- as.numeric(which(duplicated(t(data))))
    if(length(indistinguishable)>0) {
        # merge names of indistinguishable events
        valid_colnames <- colnames(data)[-indistinguishable]
        new_colnames <- valid_colnames
        invalid_colnames <- colnames(data)[indistinguishable]
        for(i in invalid_colnames) {
            for(j in valid_colnames) {
                if(all(is.na(data[,i])==is.na(data[,j]))) { # if NAs in i and j are the same
                    if(all(data[,i]==data[,j],na.rm=TRUE)) { # if not-NAs entries in i and j are the same
                        new_colnames[which(valid_colnames==j)] <- paste0(new_colnames[which(valid_colnames==j)],"|",invalid_colnames[which(invalid_colnames==i)])
                        next;
                    }
                }
            }
        }
        # remove indistinguishable events from data
        data <- data[,valid_colnames,drop=FALSE]
        colnames(data) <- new_colnames
    }
    
    # return data
    return(data)
    
}

# build a phylogenetic tree from a variants tree (adjacency_matrix) and related samples attachments (samples_attachments)
get.phylo <- function( adjacency_matrix, valid_genotypes, samples_attachments ) {
    
    # compute Manhattan distance among valid genotypes
    distance_genotypes <- as.matrix(dist(valid_genotypes,method="manhattan"))

    # consider the variants tree (adjacency_matrix) to build inner nodes structure of VERSO phylogenetic tree
    edges <- which(adjacency_matrix==1,arr.ind=TRUE)
    parents_list <- rownames(adjacency_matrix)[as.numeric(edges[,"row"])]
    children_list <- rownames(adjacency_matrix)[as.numeric(edges[,"col"])]
    edges <- cbind(parents_list,children_list)
    edges_weights <- NULL
    for(i in seq_len(nrow(edges))) {
        curr_p <- rownames(valid_genotypes)[which(colnames(valid_genotypes)==edges[i,1])]
        curr_c <- rownames(valid_genotypes)[which(colnames(valid_genotypes)==edges[i,2])]
        edges_weights <- c(edges_weights,distance_genotypes[curr_p,curr_c])
    }
    nodes_list <- unique(as.vector(edges))
    Nnode <- length(nodes_list)
    parents_list_numeric <- parents_list
    children_list_numeric <- children_list
    for(nlist in seq_len(Nnode)) {
        curr_nl <- which(parents_list==nodes_list[nlist])
        if(length(curr_nl)>0) {
            parents_list_numeric[curr_nl] <- nlist
        }
        curr_nl <- which(children_list==nodes_list[nlist])
        if(length(curr_nl)>0) {
            children_list_numeric[curr_nl] <- nlist
        }
    }
    edges <- cbind(as.numeric(parents_list_numeric),as.numeric(children_list_numeric))
    colnames(edges) <- c("Parent","Child")
    
    # now consider samples attachments
    attachments <- samples_attachments[,"Genotype"]
    tip.label <- c(names(attachments),"Reference_Genotype")
    overhead <- length(tip.label)
    edges <- edges + overhead
    for(i in seq_len(length(attachments))) {
        curr_att <- which(nodes_list==colnames(valid_genotypes)[which(rownames(valid_genotypes)==attachments[i])])+overhead
        edges <- rbind(edges,c(curr_att,i))
        edges_weights <- c(edges_weights,0)
    }
    edges <- rbind(edges,c(as.numeric(edges[1,"Parent"]),(i+1)))
    edges_weights <- c(edges_weights,0)
    rownames(edges) <- seq_len(nrow(edges))

    # build VERSO phylogenetic tree
    phylogenetic_tree <- list(edge=edges,tip.label=tip.label,Nnode=Nnode,edge.length=edges_weights,node.label=nodes_list,root.edge=0)
    class(phylogenetic_tree) <- "phylo"
    phylogenetic_tree <- ape::keep.tip(phylogenetic_tree,tip.label)

    # return VERSO phylogenetic tree
    return(phylogenetic_tree)

}

# convert B to an adjacency matrix
as.adj.matrix <- function( B, sorting = FALSE) {
    
    # create the data structure where to save the adjacency matrix obtained from B
    adj_matrix <- array(0L,dim(B))
    rownames(adj_matrix) <- colnames(B)
    colnames(adj_matrix) <- colnames(B)
    
    # set arcs in the adjacency matrix
    for(i in seq_len((nrow(B)-1))) {
        for(j in ((i+1):nrow(B))) {
            if(all(B[i,seq_len(i)]==B[j,seq_len(i)])&&(sum(B[i,])==(sum(B[j,])-1))) {
                adj_matrix[i,j] <- 1
            }
        }
    }
    
    if(sorting == TRUE) {
        # keeping root on the first place
        ord <- c(1,1+order(colnames(adj_matrix)[-1]))
        adj_matrix <- adj_matrix[ord,ord]
    }
    
    # return the adjacency matrix obtained from B
    return(adj_matrix)
    
}

# build B from an adjacency matrix where we assume genotypes and mutations to be both ordered
as.B <- function( adj_matrix, D ) {
    
    # build data structure to save results
    n_clones <- nrow(adj_matrix)
    B <- diag(n_clones)
    
    # build B
    for(k in seq_len(n_clones)) {
        idx_child <- which(adj_matrix[k,]==1,arr.ind=TRUE)
        if(length(idx_child)==1) {
            B[idx_child,] <- B[k,] + B[idx_child,]
        }
        else if(length(idx_child)>1) {
            B[idx_child,] <- sweep(B[idx_child,],2,B[k,],"+")
        }
    }
    rownames(B) <- c("r",seq_len((nrow(B)-1)))
    mycolnames <- "r"
    for(i in 2:nrow(adj_matrix)) {
        mycolnames <- c(mycolnames,as.character(which(rownames(adj_matrix)[i]==colnames(D))))
    }
    colnames(B) <- mycolnames
    
    # return B
    return(B)
    
}

# draw B
draw.B <- function( B, mut_label = colnames(B)[-1], last_mut_node_label =  TRUE) {
    
    Broot <- Node$new('r')
    Broot$mut <- B[1,]
    
    nClone <- nrow(B)
    Clones <- list(Broot)
    
    for(rP in 1:(nrow(B)-1)) {
        
        for(rC in ((rP+1):nrow(B))) {
            
            if(all(Clones[[rP]]$mut[1:rP]==B[rC,1:rP])&&(sum(Clones[[rP]]$mut)==(sum(B[rC,])-1))) {
                if(last_mut_node_label) {
                    mutName <- tail(mut_label[which(B[rC,-1]==1)], 1)
                } else {
                    mutName <- paste(mut_label[which(B[rC,-1]==1)],collapse="")  
                }
                
                Clones[[rC]] <- Clones[[rP]]$AddChild(mutName)
                Clones[[rC]]$mut <- B[rC,]
                
            }
            
        }
        
    }
    
    return(Broot)
    
}

#' Perform the inference of the maximum log-likelihood VERSO phylogenetic tree.
#' @title VERSO
#'
#' @examples
#' data(variants)
#' set.seed(12345)
#' inference = VERSO(D = variants, 
#'                   alpha = c(0.01,0.05), 
#'                   beta = c(0.01,0.05), 
#'                   check_indistinguishable = TRUE, 
#'                   num_rs = 5, 
#'                   num_iter = 100, 
#'                   n_try_bs = 50, 
#'                   num_processes = 1, 
#'                   verbose = FALSE)
#'
#' @param D Input data for the inference reporting presence (as 1), absense (as 0) or missing 
#' information (as NA) for a set of variants.
#' @param alpha False positive error rate provided as a verctor; if a vector of alpha (and beta) 
#' is provided, the inference is performed 
#' for multiple values and the solution at maximum-likelihood is returned.
#' @param beta False negative error rate provided as a verctor; if a vector of beta (and alpha) 
#' is provided, the inference is performed 
#' for multiple values and the solution at maximum-likelihood is returned.
#' @param initialization Binary matrix representing a perfect philogeny tree; genotypes are rows and mutations are columns. 
#' This parameter overrides "random_tree". 
#' @param random_tree Boolean. Shall I start MCMC search from a random tree? If FALSE (default) and initialization is NULL, search 
#' is started from a TRaIT tree (BMC Bioinformatics . 2019 Apr 25;20(1):210.  doi: 10.1186/s12859-019-2795-4). 
#' @param keep_equivalent Boolean. Shall I return results (B and C) at equivalent likelihood with the best returned solution?
#' @param check_indistinguishable Boolean. Shall I remove any indistinguishable variant 
#' from input data prior inference?
#' @param marginalize Boolean. Shall I marginalize C when computing likelihood?
#' @param num_rs Number of restarts during MCMC inference.
#' @param num_iter Maximum number of MCMC steps to be performed during the inference.
#' @param n_try_bs Number of steps without changes in likelihood of best solution after which to stop the MCMC.
#' @param num_processes Number of processes to be used during parallel execution. To execute in single process mode, 
#' this parameter needs to be set to either 1, NA or NULL.
#' @param verbose Boolean. Shall I print to screen information messages during the execution?
#' @param log_file log file where to print outputs when using parallel. If parallel execution is disabled, this parameter is ignored.
#' @return A list of 9 elements: B, C, phylogenetic_tree, corrected_genotypes, genotypes_prevalence, 
#' genotypes_summary, log_likelihood and error_rates. Here, B returns the maximum likelihood variants tree 
#' (inner nodes of the phylogenetic tree), C the attachment of patients to genotypes and phylogenetic_tree VERSO 
#' phylogenetic tree, including both variants tree and patients attachments to variants; corrected_genotypes is the 
#' corrected genotypes, which corrects D given VERSO phylogenetic tree, genotypes_prevalence the number of patients 
#' and observed prevalence of each genotype and genotypes_summary provide a summary of association of mutations 
#' to genotypes. In equivalent_solutions, solutions (B and C) with likelihood equivalent to the best solution are returned. 
#' Finally log_likelihood and error_rates return the likelihood of the inferred phylogenetic moldel and best values of alpha and beta 
#' as estimated by VERSO.
#' @export VERSO
#' @import ape
#' @import parallel
#' @importFrom Rfast rowMaxs rowsums
#' @importFrom stats runif dist
#' @importFrom utils tail
#' @importFrom data.tree Node
#'
VERSO <- function( D, 
                   alpha = NULL, 
                   beta = NULL, 
                   initialization = NULL, 
                   random_tree = FALSE, 
                   keep_equivalent = TRUE, 
                   check_indistinguishable = TRUE, 
                   marginalize = FALSE,
                   num_rs = 10, 
                   num_iter = 10000, 
                   n_try_bs = 1000, 
                   num_processes = Inf, 
                   verbose = TRUE,
                   log_file = "") {
    
    # set storage mode to integer
    storage.mode(D) <- "integer"
    
    # remove any indistinguishable variant from input data prior inference
    if(check_indistinguishable) {
        D <- check.indistinguishable(D)
        storage.mode(D) <- "integer"
    }
    
    # initialize error rates alpha and beta if not provided as inputs
    if(is.null(alpha)) {
        alpha = c(0.01,0.05,0.10)
        beta = c(0.01,0.05,0.10)
    }
    
    if(verbose) {
        message("Performing inference for a total of ",length(alpha)," different values of alpha and beta.")
    }

    # setting up parallel execution
    if(num_rs>1) {
        if(is.na(num_processes) || is.null(num_processes) || num_processes == 1) {
            num_processes = 1
        }
        else if(num_processes==Inf) {
            cores <- as.integer((detectCores()-1))
            if(cores < 2) {
                num_processes <- 1
            }
            else {
                num_processes <- min(cores,num_rs)
            }
        }
        else {
            num_processes <- min(num_processes,num_rs)
        }
        if(verbose && num_processes>1) {
            cat("Executing",num_processes,"processes via parallel...","\n", file = log_file, append = T)
        }
    }
    else {
        num_processes = 1
    }

    # if initiatilation is NULL and we do not require a random tree, we initializa with TRaIT tree
    if(is.null(initialization) && !random_tree) {

        # set initial tree from where to start MCMC search
        data <- D
        data[which(is.na(data))] <- 0
        marginal_probs <- matrix(colSums(data,na.rm=TRUE)/nrow(data),ncol=1)
        rownames(marginal_probs) <- colnames(data)
        colnames(marginal_probs) <- "Frequency"
        joint_probs <- array(NA,c(ncol(data),ncol(data)))
        rownames(joint_probs) <- colnames(data)
        colnames(joint_probs) <- colnames(data)
        for (i in seq_len(ncol(data))) {
            for (j in seq_len(ncol(data))) {
                val1 <- data[,i]
                val2 <- data[,j]
                joint_probs[i,j] <- (t(val1)%*%val2)
            }
        }
        joint_probs <- joint_probs/nrow(data)
        adjacency_matrix <- array(0,c(ncol(data),ncol(data)))
        rownames(adjacency_matrix) <- colnames(data)
        colnames(adjacency_matrix) <- colnames(data)
        pmi <- joint_probs
        for(i in seq_len(nrow(pmi))) {
            for(j in seq_len(ncol(pmi))) {
                pmi[i,j] <- log(joint_probs[i,j]/(marginal_probs[i,"Frequency"]*marginal_probs[j,"Frequency"]))
            }
        }
        ordering <- names(sort(marginal_probs[,"Frequency"],decreasing=TRUE))
        adjacency_matrix <- adjacency_matrix[ordering,ordering]
        adjacency_matrix[1,2] = 1
        if(nrow(adjacency_matrix)>2) {
            for(i in 3:nrow(adjacency_matrix)) {
                curr_c <- rownames(adjacency_matrix)[i]
                curr_candidate_p <- rownames(adjacency_matrix)[seq_len((i-1))]
                adjacency_matrix[names(which.max(pmi[curr_candidate_p,curr_c]))[1],curr_c] <- 1
            }
        }
        adjacency_matrix <- rbind(rep(0,nrow(adjacency_matrix)),adjacency_matrix)
        adjacency_matrix <- cbind(rep(0,nrow(adjacency_matrix)),adjacency_matrix)
        adjacency_matrix[1,2] = 1
        initialization <- as.B(adj_matrix=adjacency_matrix,D=D)
        
    }

    # perform the inference
    inference <- list()
    for(i in seq_len(length(alpha))) {
        
        if(verbose) {
            message(paste('Performing inference for alpha =',paste0(alpha[i],collapse=" | "),'and beta =',paste0(beta[i],collapse=" | ")))
        }
        
        inference[[i]] <- learn.VERSO.phylogenetic.tree( D = D, 
                                                         alpha = alpha[i], 
                                                         beta = beta[i], 
                                                         initialization = initialization, 
                                                         keep_equivalent = keep_equivalent, 
                                                         marginalize = marginalize, 
                                                         num_rs = num_rs, 
                                                         num_iter = num_iter, 
                                                         n_try_bs = n_try_bs, 
                                                         num_processes = num_processes, 
                                                         log_file = log_file, 
                                                         verbose = verbose )
        
    }
    
    # return the solution at maximum log-likelihood among the inferrend ones
    lik <- NULL
    for(i in seq_len(length(inference))) {
        lik <- c(lik,inference[[i]][["log_likelihood"]])
    }
    best <- which(lik==max(lik))[1]
    inference <- inference[[best]]
    B <- inference$B
    storage.mode(B) <- "integer"
    C <- inference$C
    log_likelihood <- inference[["log_likelihood"]]
    error_rates <- list(alpha=alpha[best],beta=beta[best])
    
    # compute corrected genotypes
    C_matrix <- array(0,c(nrow(D),ncol(B)))
    rownames(C_matrix) <- rownames(D)
    colnames(C_matrix) <- colnames(B)
    for(i in seq_len(nrow(C_matrix))) {
        C_matrix[i,which(rownames(B)==C[rownames(C_matrix)[i],"Genotype"])] <- 1
    }
    corrected_genotypes <- C_matrix %*% B
    corrected_genotypes <- corrected_genotypes[,colnames(D)]
    storage.mode(corrected_genotypes) <- "integer"
    
    # compute genotypes prevalence
    genotypes_prevalence <- array(NA,c(nrow(B),2))
    rownames(genotypes_prevalence) <- rownames(B)
    colnames(genotypes_prevalence) <- c("#Patients","Prevalence")
    patients <- table(C[,"Genotype"])
    prevalence <- patients/nrow(C)
    genotypes_prevalence[names(patients),"#Patients"] <- as.numeric(patients)
    genotypes_prevalence[names(prevalence),"Prevalence"] <- as.numeric(prevalence)
    
    # compute genotypes summary
    genotypes_summary <- list()
    i = 1
    for(genotypes in rownames(B)) {
        mut_list <- colnames(B)[B[i,]==1]
        genotypes_summary[[genotypes]] <- mut_list
        i = i + 1
    }
    
    # build VERSO phylogenetic tree
    phylogenetic_tree <- get.phylo(adjacency_matrix=as.adj.matrix(B),valid_genotypes=B,samples_attachments=C)

    # finally, process equivalent solutions
    if(keep_equivalent == TRUE) {
        equivalent_solutions <- inference[["equivalent_solutions"]]
        
        eq_sol_df <- do.call(rbind,  lapply(equivalent_solutions, function(x) {
            adjM <- as.adj.matrix(x$B,sorting=TRUE)
            return(as.vector(adjM))
        }))
        
        idx_uniq_sol <- which(!duplicated(eq_sol_df))
        
        equivalent_solutions <- equivalent_solutions[idx_uniq_sol]
        
        if(length(equivalent_solutions)==1) { # if we have only the best solution (no other equivalent solutions)
            equivalent_solutions <- list()
        } else {
            
            for(i in 1:length(equivalent_solutions)) {
                rownames(equivalent_solutions[[i]][["B"]]) <- paste0("G",seq_len(nrow(equivalent_solutions[[i]][["B"]])))
                colnames(equivalent_solutions[[i]][["B"]]) <- c("Reference",colnames(D)[as.numeric(colnames(equivalent_solutions[[i]][["B"]])[2:ncol(equivalent_solutions[[i]][["B"]])])])
            }
        }
        
    } else {
        
        equivalent_solutions <- NULL   
    }
    
    # return results of the inference
    results <- list(B=B,C=C,phylogenetic_tree=phylogenetic_tree,corrected_genotypes=corrected_genotypes,genotypes_prevalence=genotypes_prevalence,genotypes_summary=genotypes_summary,log_likelihood=log_likelihood,equivalent_solutions=equivalent_solutions,error_rates=error_rates)
    return(results)
    
}

#' Write a phylogenetic tree as inferred by VERSO to a newick format file.
#' @title write.newick.tree
#'
#' @examples
#' data(inference)
#' write.newick.tree(phylogenetic_tree = inference, 
#'                   phylogeny_file = "inference_tree.new")
#'
#' @param phylogenetic_tree Inference results by VERSO.
#' @param phylogeny_file File where to save the phylogenetic tree in newick format.
#' @return A phylogenetic tree as inferred by VERSO in newick format.
#' @export write.newick.tree
#' @import ape
#'
write.newick.tree <- function( phylogenetic_tree, phylogeny_file = "phylogenetic_tree.new" ) {
    
    write.tree(phylogenetic_tree$phylogenetic_tree,file=phylogeny_file)
    
}

#' @name variants
#' @title Mutation data obtained by variant calling from raw data of a 
#' selected set of SARS-CoV-2 samples available from NCBI 
#' BioProject PRJNA610428.
#' @description The dataset includes variants for a selected set of 15 
#' SARS-CoV-2 samples obtained by variant calling from raw data 
#' available from NCBI BioProject PRJNA610428.
#' @docType data
#' @usage data(variants)
#' @format SARS-CoV-2 variants
#' @source NCBI BioProject PRJNA610428
#' @return SARS-CoV-2 variants
NULL

#' @name inference
#' @title Results obtained running VERSO on the provided input dataset.
#' @description Results obtained running VERSO on the provided input dataset.
#' @docType data
#' @usage data(inference)
#' @format results obtained running VERSO on the provided input dataset
#' @return results obtained running VERSO on the provided input dataset
NULL

data("variants")

context("VERSO")

data("inference")
test_that("VERSO produces correct output", {
    expect_equal(names(inference),c("B","C","phylogenetic_tree","corrected_genotypes","genotypes_prevalence","genotypes_summary","log_likelihood","error_rates"))
})

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/frontend.R
\name{VERSO}
\alias{VERSO}
\title{VERSO}
\usage{
VERSO(
  D,
  alpha = NULL,
  beta = NULL,
  initialization = NULL,
  random_tree = FALSE,
  keep_equivalent = TRUE,
  check_indistinguishable = TRUE,
  marginalize = FALSE,
  num_rs = 10,
  num_iter = 10000,
  n_try_bs = 1000,
  num_processes = Inf,
  verbose = TRUE,
  log_file = ""
)
}
\arguments{
\item{D}{Input data for the inference reporting presence (as 1), absense (as 0) or missing 
information (as NA) for a set of variants.}

\item{alpha}{False positive error rate provided as a verctor; if a vector of alpha (and beta) 
is provided, the inference is performed 
for multiple values and the solution at maximum-likelihood is returned.}

\item{beta}{False negative error rate provided as a verctor; if a vector of beta (and alpha) 
is provided, the inference is performed 
for multiple values and the solution at maximum-likelihood is returned.}

\item{initialization}{Binary matrix representing a perfect philogeny tree; genotypes are rows and mutations are columns. 
This parameter overrides "random_tree".}

\item{random_tree}{Boolean. Shall I start MCMC search from a random tree? If FALSE (default) and initialization is NULL, search 
is started from a TRaIT tree (BMC Bioinformatics . 2019 Apr 25;20(1):210.  doi: 10.1186/s12859-019-2795-4).}

\item{keep_equivalent}{Boolean. Shall I return results (B and C) at equivalent likelihood with the best returned solution?}

\item{check_indistinguishable}{Boolean. Shall I remove any indistinguishable variant 
from input data prior inference?}

\item{marginalize}{Boolean. Shall I marginalize C when computing likelihood?}

\item{num_rs}{Number of restarts during MCMC inference.}

\item{num_iter}{Maximum number of MCMC steps to be performed during the inference.}

\item{n_try_bs}{Number of steps without changes in likelihood of best solution after which to stop the MCMC.}

\item{num_processes}{Number of processes to be used during parallel execution. To execute in single process mode, 
this parameter needs to be set to either 1, NA or NULL.}

\item{verbose}{Boolean. Shall I print to screen information messages during the execution?}

\item{log_file}{log file where to print outputs when using parallel. If parallel execution is disabled, this parameter is ignored.}
}
\value{
A list of 9 elements: B, C, phylogenetic_tree, corrected_genotypes, genotypes_prevalence, 
genotypes_summary, log_likelihood and error_rates. Here, B returns the maximum likelihood variants tree 
(inner nodes of the phylogenetic tree), C the attachment of patients to genotypes and phylogenetic_tree VERSO 
phylogenetic tree, including both variants tree and patients attachments to variants; corrected_genotypes is the 
corrected genotypes, which corrects D given VERSO phylogenetic tree, genotypes_prevalence the number of patients 
and observed prevalence of each genotype and genotypes_summary provide a summary of association of mutations 
to genotypes. In equivalent_solutions, solutions (B and C) with likelihood equivalent to the best solution are returned. 
Finally log_likelihood and error_rates return the likelihood of the inferred phylogenetic moldel and best values of alpha and beta 
as estimated by VERSO.
}
\description{
Perform the inference of the maximum log-likelihood VERSO phylogenetic tree.
}
\examples{
data(variants)
set.seed(12345)
inference = VERSO(D = variants, 
                  alpha = c(0.01,0.05), 
                  beta = c(0.01,0.05), 
                  check_indistinguishable = TRUE, 
                  num_rs = 5, 
                  num_iter = 100, 
                  n_try_bs = 50, 
                  num_processes = 1, 
                  verbose = FALSE)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{inference}
\alias{inference}
\title{Results obtained running VERSO on the provided input dataset.}
\format{
results obtained running VERSO on the provided input dataset
}
\usage{
data(inference)
}
\value{
results obtained running VERSO on the provided input dataset
}
\description{
Results obtained running VERSO on the provided input dataset.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{variants}
\alias{variants}
\title{Mutation data obtained by variant calling from raw data of a 
selected set of SARS-CoV-2 samples available from NCBI 
BioProject PRJNA610428.}
\format{
SARS-CoV-2 variants
}
\source{
NCBI BioProject PRJNA610428
}
\usage{
data(variants)
}
\value{
SARS-CoV-2 variants
}
\description{
The dataset includes variants for a selected set of 15 
SARS-CoV-2 samples obtained by variant calling from raw data 
available from NCBI BioProject PRJNA610428.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/frontend.R
\name{write.newick.tree}
\alias{write.newick.tree}
\title{write.newick.tree}
\usage{
write.newick.tree(phylogenetic_tree, phylogeny_file = "phylogenetic_tree.new")
}
\arguments{
\item{phylogenetic_tree}{Inference results by VERSO.}

\item{phylogeny_file}{File where to save the phylogenetic tree in newick format.}
}
\value{
A phylogenetic tree as inferred by VERSO in newick format.
}
\description{
Write a phylogenetic tree as inferred by VERSO to a newick format file.
}
\examples{
data(inference)
write.newick.tree(phylogenetic_tree = inference, 
                  phylogeny_file = "inference_tree.new")

}
